"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getOrCreateAtom = void 0;
var recoil_1 = require("recoil");
var storeMap = new Map();
function getOrCreateAtom(store) {
    var cached = storeMap.get(store.key);
    if (!cached) {
        var newAtom = (0, recoil_1.atom)({
            key: store.key,
            default: store.get(),
            effects_UNSTABLE: [
                function (_a) {
                    var onSet = _a.onSet;
                    onSet(function (newValue) {
                        // null should only stay as JavaScript state
                        if (newValue === null) {
                            return;
                        }
                        store.__setWithoutDispatch(newValue);
                    });
                },
            ],
        });
        storeMap.set(store.key, newAtom);
        return newAtom;
    }
    return cached;
}
exports.getOrCreateAtom = getOrCreateAtom;
