"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.usePersistState = void 0;
var react_1 = require("react");
var recoil_1 = require("recoil");
var getOrCreateAtom_1 = require("./getOrCreateAtom");
function usePersistState(store) {
    var atom = (0, react_1.useMemo)(function () {
        return (0, getOrCreateAtom_1.getOrCreateAtom)(store);
    }, [store]);
    var _a = (0, recoil_1.useRecoilState)(atom), value = _a[0], setOrUpdate = _a[1];
    (0, react_1.useEffect)(function () {
        store.__subscribe(setOrUpdate);
        return function () {
            store.__unsubscribe(setOrUpdate);
        };
    }, [store, setOrUpdate]);
    return [value, setOrUpdate];
}
exports.usePersistState = usePersistState;
